<script lang="ts">
  import Section from '$lib/components/sections/Section.svelte';
  import BaseLayout from '$lib/components/layouts/BaseLayout.svelte';
  import JournalCard from '$lib/components/cards/JournalCard.svelte';
  import type { PageData } from './$types';
  import { axiosInstance } from '$lib/config';
  import Pagination from '$lib/components/Pagination.svelte';

  export let data: PageData;

  let journals = data?.journal.data,
    page = data.page || 1,
    pages = data?.journal.pages;

  $: {
    journals = data?.journal.data;
    page = data.page || 1;
    pages = data?.journal.pages;
  }

  async function handleSearch(event: any) {
    const res = await axiosInstance.get('/journal', { params: { ...(event.detail && { name: event.detail }) } });

    if (event.detail) {
      pages = 0;
    } else {
      pages = data?.journal.pages;
    }

    journals = res.data.data;
  }
</script>

<svelte:head>
    <title>Журналы</title>
</svelte:head>

<BaseLayout>
    <Section title="Журналы" class="mt-16" {handleSearch}>
        <section class="grid 2xl:grid-cols-4 lg:grid-cols-2 gap-8">
            {#each journals as { name, href }}
                <JournalCard {name} {href}/>
            {/each}
        </section>
        <Pagination {page} {pages}/>
    </Section>
</BaseLayout>